<?php

namespace Tests\Unit\Models;

use App\Exceptions\EmptyCartException;
use App\Exceptions\ViolatePolicyException;
use App\Models\Cart;
use App\Models\CartItem;
use App\Models\Order;
use App\Models\OrderItem;
use App\Models\OrderStatus;
use App\Models\Plan;
use App\Models\PlanPolicy;
use App\Models\Product;
use App\Models\ProductStock;
use App\Models\ProductVariantOption;
use App\Models\Subscription;
use Carbon\Carbon;
use Illuminate\Database\Eloquent\Factories\Sequence;
use Illuminate\Foundation\Testing\RefreshDatabase;
use Tests\TestCase;
use Tests\Traits\FakeSetting;

class CartTest extends TestCase
{
    use RefreshDatabase, FakeSetting;

    /**
     * @throws \Illuminate\Contracts\Container\BindingResolutionException
     */
    protected function setUp(): void
    {
        parent::setUp(); // TODO: Change the autogenerated stub

        $this->setupSetting();
    }

    public function testCalculateTotalAmountItemInCart()
    {
        /** @var Cart $cart */
        $cart = Cart::factory()->create();

        $stocks = ProductStock::factory()
                              ->count(2)
                              ->for(Product::factory()->state(['price' => 2000]))
                              ->state(new Sequence(
                                  ['price' => 200],
                                  ['price' => 300]
                              ))
                              ->create();

        foreach ($stocks as $stock) {
            $cart->addItem([
                'product_id' => $stock->product_id,
                'product_stock_id' => $stock->id,
                'product_type_id' => 1,
                'quantity' => 1
            ]);
        }

        $this->assertEquals(4500, $cart->totalAmount());
    }

    public function testCheckoutWithoutItem()
    {
        /** @var Cart $cart */
        $cart = Cart::factory()->create();

        $this->expectException(EmptyCartException::class);

        $cart->checkout();
    }

    public function testExcludeCertainItemAmount()
    {
        Product::factory()
               ->count(3)
               ->state(new Sequence(
                   ['price' => 500],
                   ['price' => 1000],
                   ['price' => 2000]
               ))
               ->has(ProductStock::factory()->state(['price' => 0]), 'stocks')
               ->create();

        /** @var Cart $cart */
        $cart = Cart::factory()
                    ->has(CartItem::factory()
                                  ->count(3)
                                  ->state(new Sequence(
                                      ['product_id' => 3, 'quantity' => 1, 'product_type_id' => 3, 'product_stock_id' => 3],
                                      ['product_id' => 1, 'quantity' => 3, 'product_type_id' => 1, 'product_stock_id' => 1],
                                      ['product_id' => 2, 'quantity' => 1, 'product_type_id' => 2, 'product_stock_id' => 2]
                                  )),
                        'items')
                    ->create();

        $this->assertEquals(3000, $cart->totalAmount([1]));
    }
}
